# generated by datamodel-codegen:
#   filename:  data_room.json

from __future__ import annotations

from enum import Enum
from typing import Optional, Sequence, Union

from pydantic import BaseModel, Field, RootModel, conint


class Kind(Enum):
    media = 'media'


class Version(Enum):
    v0 = 'v0'


class Kind19(Enum):
    BASE = 'BASE'


class AudienceReference7(BaseModel):
    kind: Kind19


class Kind20(Enum):
    CUSTOM = 'CUSTOM'


class AudienceReference8(BaseModel):
    id: str
    kind: Kind20


class Kind21(Enum):
    SEED = 'SEED'


class AudienceReference9(BaseModel):
    audienceType: str
    kind: Kind21


class AudienceReference(
    RootModel[Union[AudienceReference7, AudienceReference8, AudienceReference9]]
):
    root: Union[AudienceReference7, AudienceReference8, AudienceReference9]


class BooleanOp(Enum):
    AND = 'AND'
    OR = 'OR'


class CombineOperator(Enum):
    INTERSECT = 'INTERSECT'
    UNION = 'UNION'
    DIFF = 'DIFF'


class Kind22(Enum):
    LOOKALIKE = 'LOOKALIKE'


class CustomAudienceDefinition5(BaseModel):
    excludeSeedAudience: Optional[bool] = None
    kind: Kind22
    reach: conint(ge=0)
    sourceRef: AudienceReference


class Kind23(Enum):
    RULE_BASED = 'RULE_BASED'


class Features(Enum):
    ENABLE_DEBUG_MODE = 'ENABLE_DEBUG_MODE'
    ENABLE_INSIGHTS = 'ENABLE_INSIGHTS'
    ENABLE_REMARKETING = 'ENABLE_REMARKETING'
    ENABLE_LOOKALIKE_AUDIENCES = 'ENABLE_LOOKALIKE_AUDIENCES'
    ENABLE_RULED_BASED_AUDIENCES = 'ENABLE_RULED_BASED_AUDIENCES'
    ENABLE_HIDE_ABSOLUTE_AUDIENCE_SIZES = 'ENABLE_HIDE_ABSOLUTE_AUDIENCE_SIZES'


class FilterOperator(Enum):
    CONTAINS_ANY_OF = 'CONTAINS_ANY_OF'
    CONTAINS_NONE_OF = 'CONTAINS_NONE_OF'
    CONTAINS_ALL_OF = 'CONTAINS_ALL_OF'
    EMPTY = 'EMPTY'
    NOT_EMPTY = 'NOT_EMPTY'


class FormatType(Enum):
    STRING = 'STRING'
    INTEGER = 'INTEGER'
    FLOAT = 'FLOAT'
    EMAIL = 'EMAIL'
    DATE_ISO8601 = 'DATE_ISO8601'
    PHONE_NUMBER_E164 = 'PHONE_NUMBER_E164'
    HASH_SHA256_HEX = 'HASH_SHA256_HEX'


class HashingAlgorithm(Enum):
    SHA256_HEX = 'SHA256_HEX'


class ModelEvaluationType(Enum):
    ROC_CURVE = 'ROC_CURVE'
    DISTANCE_TO_EMBEDDING = 'DISTANCE_TO_EMBEDDING'
    JACCARD = 'JACCARD'


class Permission(Enum):
    VIEW_OVERLAP = 'VIEW_OVERLAP'
    VIEW_INSIGHTS = 'VIEW_INSIGHTS'
    PROVIDE_SEED_AUDIENCE = 'PROVIDE_SEED_AUDIENCE'
    PROVIDE_BASE_AUDIENCE = 'PROVIDE_BASE_AUDIENCE'
    CREATE_CUSTOM_AUDIENCE = 'CREATE_CUSTOM_AUDIENCE'
    EXPORT_AUDIENCE = 'EXPORT_AUDIENCE'
    MODEL_QUALITY = 'MODEL_QUALITY'


class PublishedPolicy(BaseModel):
    leafId: str
    policyId: str
    publishedAt: Optional[str] = None
    publishedByEmail: Optional[str] = None


class AudienceFilter(BaseModel):
    attribute: str
    operator: FilterOperator
    values: Optional[Sequence[str]] = None


class AudienceFilters(BaseModel):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class ModelEvaluationConfig(BaseModel):
    postScopeMerge: Sequence[ModelEvaluationType]
    preScopeMerge: Sequence[ModelEvaluationType]


class ParticipantGroup(BaseModel):
    emails: Sequence[str]
    id: str
    organizationId: Optional[str] = None
    permissions: Sequence[Permission]
    role: str


class AudienceCombinator(BaseModel):
    filters: Optional[AudienceFilters] = None
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition6(BaseModel):
    combine: Optional[Sequence[AudienceCombinator]] = None
    filters: Optional[AudienceFilters] = None
    kind: Kind23
    sourceRef: AudienceReference


class CustomAudienceDefinition(
    RootModel[Union[CustomAudienceDefinition5, CustomAudienceDefinition6]]
):
    root: Union[CustomAudienceDefinition5, CustomAudienceDefinition6]


class CustomAudience(BaseModel):
    createdAt: str
    createdBy: str
    definition: CustomAudienceDefinition
    id: str
    name: str
    sharedWith: Optional[Sequence[str]] = []


class DataRoom1(BaseModel):
    kind: Kind
    customAudiences: Sequence[CustomAudience]
    features: Sequence[Features]
    hashMatchingIdWith: Optional[HashingAlgorithm] = None
    matchingIdFormat: FormatType
    modelEvaluation: Optional[ModelEvaluationConfig] = None
    name: str
    participantGroups: Sequence[ParticipantGroup]
    policies: Sequence[PublishedPolicy]
    version: Version


class DataRoom(RootModel[DataRoom1]):
    root: DataRoom1 = Field(..., title='DataRoom')
